Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 14276)
@@ -89,5 +89,5 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zgrarem, zgraref, zgrapoc, zgrapof, zgrabsi
       REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zgramigrem, zgramigref, zgramigpoc, zgramigpof
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zstrn, zgramigbsi
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zgramigbsi
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   zw3d, zz2ligprod
       !!---------------------------------------------------------------------
@@ -236,5 +236,5 @@
                zgraztotn = zgrazdc * quotad(ji,jj,jk) + zgrazz + zgraznc * quotan(ji,jj,jk)   &
                &   + zgrazpoc + zgrazffep + zgrazffeg
-               zgraztotf = zgrazdf + zgraznf + zgrazz * ferat3 + zgrazpof + zgrazfffp + zgrazfffg
+               zgraztotf = zgrazdf + zgraznf + zgrazz * feratz + zgrazpof + zgrazfffp + zgrazfffg
 
                ! Total grazing ( grazing by microzoo is already computed in p4zmicro )
@@ -251,5 +251,5 @@
                zgrasratf =  ( zgraztotf + rtrn )/ ( zgraztotc + rtrn )
                zgrasratn =  ( zgraztotn + rtrn )/ ( zgraztotc + rtrn )
-               zepshert  = MIN( 1., zgrasratn, zgrasratf / ferat3)
+               zepshert  = MIN( 1., zgrasratn, zgrasratf / feratm)
                zbeta     = MAX(0., (epsher2 - epsher2min) )
                ! Food quantity deprivation of GGE
@@ -298,5 +298,5 @@
                zprcaca = part2 * zprcaca
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrazcal - zprcaca
-               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2. * ( zgrazcal + zprcaca )
+               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + 2. * ( zgrazcal - zprcaca )
                tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) - zgrazcal + zprcaca
  
@@ -305,8 +305,8 @@
                zgrarem(ji,jj,jk) = zgraztotc * ( 1. - zepsherv - unass2 ) &
                &         + ( 1. - epsher2 - unass2 ) / ( 1. - epsher2 ) * ztortz
-               zgraref(ji,jj,jk) = zgraztotc * MAX( 0. , ( 1. - unass2 ) * zgrasratf - ferat3 * zepsherv )    &
-               &         + ferat3 * ( ( 1. - epsher2 - unass2 ) /( 1. - epsher2 ) * ztortz )
+               zgraref(ji,jj,jk) = zgraztotc * MAX( 0. , ( 1. - unass2 ) * zgrasratf - feratm * zepsherv )    &
+               &         + feratm * ( ( 1. - epsher2 - unass2 ) /( 1. - epsher2 ) * ztortz )
                zgrapoc(ji,jj,jk) = zgraztotc * unass2 + zmortzgoc
-               zgrapof(ji,jj,jk) = zgraztotf * unass2 + ferat3 * zmortzgoc
+               zgrapof(ji,jj,jk) = zgraztotf * unass2 + feratm * zmortzgoc
             END DO 
          END DO
@@ -320,23 +320,7 @@
          ALLOCATE( zgramigrem(jpi,jpj), zgramigref(jpi,jpj), zgramigpoc(jpi,jpj), zgramigpof(jpi,jpj) )
          ALLOCATE( zgramigbsi(jpi,jpj) )
-         ALLOCATE( zstrn(jpi,jpj) )
          zgramigrem(:,:) = 0.0    ;   zgramigref(:,:) = 0.0
          zgramigpoc(:,:) = 0.0    ;   zgramigpof(:,:) = 0.0
          zgramigbsi(:,:) = 0.0
-
-         ! compute the day length depending on latitude and the day
-         zrum = REAL( nday_year - 80, wp ) / REAL( nyear_len(1), wp )
-         zcodel = ASIN(  SIN( zrum * rpi * 2._wp ) * SIN( rad * 23.5_wp )  )
-
-         ! day length in hours
-         zstrn(:,:) = 0.
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zargu = TAN( zcodel ) * TAN( gphit(ji,jj) * rad )
-               zargu = MAX( -1., MIN(  1., zargu ) )
-               zstrn(ji,jj) = MAX( 0.0, 24. - 2. * ACOS( zargu ) / rad / 15. )
-               zstrn(ji,jj) = MIN(0.75, MAX( 0.25, zstrn(ji,jj) / 24.) )
-            END DO
-         END DO
 
         ! Compute the amount of materials that will go into vertical migration
@@ -347,5 +331,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zmigreltime = (1. - zstrn(ji,jj))
+                  zmigreltime = (1. - strn(ji,jj))
                   IF ( gdept_n(ji,jj,jk) <= heup(ji,jj) ) THEN
                      zgramigrem(ji,jj) = zgramigrem(ji,jj) + xfracmig * zgrarem(ji,jj,jk) * (1. - zmigreltime )    &
@@ -389,6 +373,4 @@
          ! ------------------------------
          DEALLOCATE( zgramigrem, zgramigref, zgramigpoc, zgramigpof, zgramigbsi )
-         DEALLOCATE( zstrn )
-
       ! End of the ln_dvm_meso part
       ENDIF
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 14276)
@@ -187,5 +187,5 @@
                zgrasratf = ( zgraztotf + rtrn ) / ( zgraztotc + rtrn )
                zgrasratn = ( zgraztotn + rtrn ) / ( zgraztotc + rtrn )
-               zepshert  =  MIN( 1., zgrasratn, zgrasratf / ferat3)
+               zepshert  =  MIN( 1., zgrasratn, zgrasratf / feratz)
                zbeta     = MAX(0., (epsher - epshermin) )
                ! Food quantity deprivation of the GGE
@@ -196,5 +196,5 @@
                zepsherv  = zepsherf * zepshert * zepsherq
                ! Excretion of Fe
-               zgrafer   = zgraztotc * MAX( 0. , ( 1. - unass ) * zgrasratf - ferat3 * zepsherv ) 
+               zgrafer   = zgraztotc * MAX( 0. , ( 1. - unass ) * zgrasratf - feratz * zepsherv ) 
                ! Excretion of C, N, P
                zgrarem   = zgraztotc * ( 1. - zepsherv - unass )
@@ -236,5 +236,5 @@
                prodpoc(ji,jj,jk) = prodpoc(ji,jj,jk) + zmortz
                conspoc(ji,jj,jk) = conspoc(ji,jj,jk) - zgrazpoc
-               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz - zgrazpof
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + feratz * zmortz - zgrazpof
                !
                ! Calcite remineralization due to zooplankton activity
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 14276)
@@ -25,5 +25,4 @@
    REAL(wp), PUBLIC ::   wchln    !: Quadratic mortality rate of nanophytoplankton
    REAL(wp), PUBLIC ::   wchld    !: Quadratic mortality rate of diatoms
-   REAL(wp), PUBLIC ::   wchldm   !: Maximum quadratic mortality rate of diatoms
    REAL(wp), PUBLIC ::   mpratn   !: Linear mortality rate of nanophytoplankton
    REAL(wp), PUBLIC ::   mpratd   !: Linear mortality rate of diatoms
@@ -63,7 +62,7 @@
       !!---------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk
-      REAL(wp) ::   zsizerat, zcompaph
+      REAL(wp) ::   zcompaph
       REAL(wp) ::   zfactfe, zfactch, zprcaca, zfracal
-      REAL(wp) ::   ztortp , zrespp , zmortp 
+      REAL(wp) ::   ztortp , zrespp , zmortp, zlim1, zlim2 
       CHARACTER (len=25) ::   charout
       !!---------------------------------------------------------------------
@@ -76,14 +75,10 @@
             DO ji = 1, jpi
                zcompaph = MAX( ( trb(ji,jj,jk,jpphy) - 1e-8 ), 0.e0 )
-               !     When highly limited by macronutrients, very small cells 
-               !     dominate the community. As a consequence, aggregation
-               !     due to turbulence is negligible. Mortality is also set
-               !     to 0
-               zsizerat = MIN(1., MAX( 0., (quotan(ji,jj,jk) - 0.2) / 0.3) ) * trb(ji,jj,jk,jpphy)
-
                ! Quadratic mortality of nano due to aggregation during
                ! blooms (Doney et al. 1996)
                ! -----------------------------------------------------
-               zrespp = wchln * 1.e6 * xstep * xdiss(ji,jj,jk) * zcompaph * zsizerat 
+               zlim2   = xlimphy(ji,jj,jk) * xlimphy(ji,jj,jk)
+               zlim1   = 0.25 * ( 1. - zlim2 ) / ( 0.25 + zlim2 ) * trb(ji,jj,jk,jpphy)
+               zrespp  = wchln * 1.e6 * xstep * zlim1 * xdiss(ji,jj,jk) * zcompaph
 
                ! Phytoplankton linear mortality
@@ -91,5 +86,5 @@
                ! extinction of nanophyto in highly limited areas
                ! ----------------------------------------------------
-               ztortp = mpratn * xstep * zcompaph / ( xkmort + trb(ji,jj,jk,jpphy) ) * zsizerat
+               ztortp = mpratn * xstep * zcompaph / ( xkmort + trb(ji,jj,jk,jpphy) ) * trb(ji,jj,jk,jpphy)
 
                zmortp = zrespp + ztortp
@@ -170,5 +165,5 @@
                zlim2   = xlimdia(ji,jj,jk) * xlimdia(ji,jj,jk)
                zlim1   = 0.25 * ( 1. - zlim2 ) / ( 0.25 + zlim2 ) 
-               zrespp2 = 1.e6 * xstep * (  wchld + wchldm * zlim1 ) * xdiss(ji,jj,jk) * zcompadi * trb(ji,jj,jk,jpdia)
+               zrespp2 = 1.e6 * xstep * wchld * zlim1 * xdiss(ji,jj,jk) * zcompadi * trb(ji,jj,jk,jpdia)
 
                ! Phytoplankton linear mortality
@@ -228,5 +223,5 @@
       INTEGER ::   ios   ! Local integer
       !
-      NAMELIST/namp4zmort/ wchln, wchld, wchldm, mpratn, mpratd
+      NAMELIST/namp4zmort/ wchln, wchld, mpratn, mpratd
       !!----------------------------------------------------------------------
       !
@@ -249,5 +244,4 @@
          WRITE(numout,*) '      quadratic mortality of phytoplankton        wchln  =', wchln
          WRITE(numout,*) '      maximum quadratic mortality of diatoms      wchld  =', wchld
-         WRITE(numout,*) '      maximum quadratic mortality of diatoms      wchldm =', wchldm
          WRITE(numout,*) '      phytoplankton mortality rate                mpratn =', mpratn
          WRITE(numout,*) '      Diatoms mortality rate                      mpratd =', mpratd
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zopt.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zopt.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zopt.F90	(revision 14276)
@@ -67,5 +67,5 @@
       REAL(wp), DIMENSION(jpi,jpj    ) :: zdepmoy, zetmp1, zetmp2, zetmp3, zetmp4
       REAL(wp), DIMENSION(jpi,jpj    ) :: zqsr100, zqsr_corr
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpar, ze0, ze1, ze2, ze3, zchl3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze0, ze1, ze2, ze3, zchl3d
       !!---------------------------------------------------------------------
       !
@@ -206,5 +206,5 @@
                  heup(ji,jj) = gdepw_n(ji,jj,jk+1)     ! Euphotic layer depth
               ENDIF
-              IF( etot_ndcy(ji,jj,jk) * tmask(ji,jj,jk) >= 0.50 )  THEN
+              IF( etot_ndcy(ji,jj,jk) * tmask(ji,jj,jk) >= 0.10 )  THEN
                  heup_01(ji,jj) = gdepw_n(ji,jj,jk+1)  ! Euphotic layer depth (light level definition)
               ENDIF
@@ -235,6 +235,6 @@
       END DO
       !
-      emoy(:,:,:) = etot(:,:,:)       ! PAR
-      zpar(:,:,:) = etot_ndcy(:,:,:)  ! diagnostic : PAR with no diurnal cycle 
+      emoy(:,:,:)  = etot(:,:,:)       ! PAR
+      etotm(:,:,:) = etot_ndcy(:,:,:)  ! diagnostic : PAR with no diurnal cycle 
       !
       DO jk = 1, nksrp
@@ -244,5 +244,5 @@
                   z1_dep = 1. / ( zdepmoy(ji,jj) + rtrn )
                   emoy (ji,jj,jk) = zetmp1(ji,jj) * z1_dep
-                  zpar (ji,jj,jk) = zetmp2(ji,jj) * z1_dep
+                  etotm(ji,jj,jk) = zetmp2(ji,jj) * z1_dep
                ENDIF
             END DO
@@ -313,5 +313,5 @@
         IF( knt == nrdttrc ) THEN
            IF( iom_use( "Heup"  ) ) CALL iom_put( "Heup" , heup(:,:  ) * tmask(:,:,1) )  ! euphotic layer deptht
-           IF( iom_use( "PARDM" ) ) CALL iom_put( "PARDM", zpar(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
+           IF( iom_use( "PARDM" ) ) CALL iom_put( "PARDM", etotm(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
            IF( iom_use( "PAR"   ) ) CALL iom_put( "PAR"  , emoy(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
         ENDIF
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 14276)
@@ -67,13 +67,12 @@
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zsilfac, znanotot, zdiattot, zconctemp, zconctemp2
-      REAL(wp) ::   zratio, zmax, zsilim, ztn, zadap, zlim, zsilfac2, zsiborn
+      REAL(wp) ::   zratio, zmax, zsilim, ztn, zadap, zlim, zsiborn
       REAL(wp) ::   zprod, zproreg, zproreg2, zprochln, zprochld
       REAL(wp) ::   zdocprod, zpislopen, zpisloped, zfact
-      REAL(wp) ::   zratiosi, zmaxsi, zlimfac, zsizetmp
-      REAL(wp) ::   zrum, zcodel, zargu, zval, zfeup, chlcnm_n, chlcdm_n
+      REAL(wp) ::   zratiosi, zmaxsi, zlimfac, zsizetmp, zfecnm, zfecdm
+      REAL(wp) ::   zrum, zcodel, zargu, zval, zfeup
       CHARACTER (len=25) :: charout
       REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: zw2d
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: zw3d
-      REAL(wp), DIMENSION(jpi,jpj    ) :: zstrn
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprmaxn,zprmaxd
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpislopeadn, zpislopeadd, zysopt  
@@ -94,4 +93,5 @@
       zprbio  (:,:,:) = 0._wp ; zprchld (:,:,:) = 0._wp ; zprchln (:,:,:) = 0._wp 
       zmxl_fac(:,:,:) = 0._wp ; zmxl_chl(:,:,:) = 0._wp 
+      consfe3 (:,:,:) = 0._wp
 
       ! Computation of the maximimum production. Based on a Q10 description
@@ -100,19 +100,4 @@
       zprmaxn(:,:,:) = 0.8_wp * r1_rday * tgfunc(:,:,:)
       zprmaxd(:,:,:) = zprmaxn(:,:,:)
-
-      ! compute the day length depending on latitude and the day
-      ! Astronomical parameterization taken from HAMOCC3
-      zrum = REAL( nday_year - 80, wp ) / REAL( nyear_len(1), wp )
-      zcodel = ASIN(  SIN( zrum * rpi * 2._wp ) * SIN( rad * 23.5_wp )  )
-
-      ! day length in hours
-      zstrn(:,:) = 0.
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zargu = TAN( zcodel ) * TAN( gphit(ji,jj) * rad )
-            zargu = MAX( -1., MIN(  1., zargu ) )
-            zstrn(ji,jj) = MAX( 0.0, 24. - 2. * ACOS( zargu ) / rad / 15. )
-         END DO
-      END DO
 
       ! Impact of the day duration and light intermittency on phytoplankton growth
@@ -127,5 +112,5 @@
             DO ji = 1, jpi
                IF( etot_ndcy(ji,jj,jk) > 1.E-3 ) THEN
-                  zval = MAX( 1., zstrn(ji,jj) )
+                  zval = MAX( 1., strn(ji,jj) )
                   IF( gdepw_n(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
                      zval = zval * MIN(1., heup_01(ji,jj) / ( hmld(ji,jj) + rtrn ))
@@ -225,7 +210,7 @@
                    ! Si/C of diatoms
                    ! ------------------------
-                   ! Si/C increases with iron stress and silicate availability (zsilfac)
+                   ! Si/C increases with iron stress and silicate availability
                    ! Si/C is arbitrariliy increased for very high Si concentrations
-                   ! to mimic the very high ratios observed in the Southern Ocean (zsilfac2)
+                   ! to mimic the very high ratios observed in the Southern Ocean (zsilfac)
                    ! A parameterization derived from Flynn (2003) is used for the control
                    ! when Si is not limiting which is similar to the parameterisation
@@ -236,15 +221,15 @@
                  zsiborn = trb(ji,jj,1,jpsil)**3
                  IF (gphit(ji,jj) < -30.0 ) THEN
-                   zsilfac2 = 1. + 2. * zsiborn / ( zsiborn + xksi2**3 )
+                   zsilfac = 1. + 2. * zsiborn / ( zsiborn + xksi2**3 )
                  ELSE
-                   zsilfac2 = 1. +      zsiborn / ( zsiborn + xksi2**3 )
+                   zsilfac = 1. +      zsiborn / ( zsiborn + xksi2**3 )
                  ENDIF
-                 zratiosi = 1.0 - trb(ji,jj,jk,jpdsi) / ( trb(ji,jj,jk,jpdia) + rtrn ) / ( zsilfac2 * grosip * 3.0 + rtrn )
+                 zratiosi = 1.0 - trb(ji,jj,jk,jpdsi) / ( trb(ji,jj,jk,jpdia) + rtrn ) / ( zsilfac * grosip * 3.0 + rtrn )
                  zratiosi = MAX(0., MIN(1.0, zratiosi) )
                  zmaxsi  = (1.0 + 0.1**4) * zratiosi**4 / ( zratiosi**4 + 0.1**4 )
                  IF ( xlimsi(ji,jj,jk) /= xlimdia(ji,jj,jk) ) THEN
-                    zysopt(ji,jj,jk) = zlim * zsilfac2 * grosip * 1.0 * zmaxsi
+                    zysopt(ji,jj,jk) = zlim * zsilfac * grosip * 1.0 * zmaxsi
                  ELSE
-                    zysopt(ji,jj,jk) = zlim * zsilfac2 * grosip * 1.0 * zsilim**0.7 * zmaxsi
+                    zysopt(ji,jj,jk) = zlim * zsilfac * grosip * 1.0 * zsilim**0.7 * zmaxsi
                  ENDIF
               ENDIF
@@ -291,7 +276,8 @@
                   ! do not suggest it for accimated cells. Uptake is
                   ! downregulated when the quota is close to the maximum quota
-                  zratio = 1.0 - MIN(1.0,trb(ji,jj,jk,jpnfe) / ( trb(ji,jj,jk,jpphy) * fecnm + rtrn ) )
+                  zfecnm = xqfuncfecn(ji,jj,jk) + ( fecnm - xqfuncfecn(ji,jj,jk) ) * ( xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk) )
+                  zratio = 1.0 - MIN(1.0,trb(ji,jj,jk,jpnfe) / ( trb(ji,jj,jk,jpphy) * zfecnm + rtrn ) )
                   zmax   = MAX( 0., MIN( 1.0, zratio**2/ (0.05**2+zratio**2) ) ) 
-                  zprofen(ji,jj,jk) = fecnm * zprmaxn(ji,jj,jk) * ( 1.0 - fr_i(ji,jj) )  &
+                  zprofen(ji,jj,jk) = zfecnm * zprmaxn(ji,jj,jk) * ( 1.0 - fr_i(ji,jj) )  &
                   &          * (1. + 0.8 * xnanono3(ji,jj,jk) / ( rtrn + xnanono3(ji,jj,jk)  &
                   &          + xnanonh4(ji,jj,jk) ) * (1. - xnanofer(ji,jj,jk) ) )   &
@@ -317,7 +303,8 @@
                   ! do not suggest it for accimated cells. Uptake is
                   ! downregulated when the quota is close to the maximum quota
-                  zratio = 1.0 - MIN(1.0, trb(ji,jj,jk,jpdfe) / ( trb(ji,jj,jk,jpdia) * fecdm + rtrn ) )
+                  zfecdm = xqfuncfecd(ji,jj,jk) + ( fecdm - xqfuncfecd(ji,jj,jk) ) * ( xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk) )
+                  zratio = 1.0 - MIN(1.0, trb(ji,jj,jk,jpdfe) / ( trb(ji,jj,jk,jpdia) * zfecdm + rtrn ) )
                   zmax   = MAX( 0., MIN( 1.0, zratio**2/ (0.05**2+zratio**2) ) ) 
-                  zprofed(ji,jj,jk) = fecdm * zprmaxd(ji,jj,jk) * (1.0 - fr_i(ji,jj) )  &
+                  zprofed(ji,jj,jk) = zfecdm * zprmaxd(ji,jj,jk) * (1.0 - fr_i(ji,jj) )  &
                   &          * (1. + 0.8 * xdiatno3(ji,jj,jk) / ( rtrn + xdiatno3(ji,jj,jk)  &
                   &          + xdiatnh4(ji,jj,jk) ) * (1. - xdiatfer(ji,jj,jk) ) )   &
@@ -339,9 +326,5 @@
                   zprod    = rday * zprorcan(ji,jj,jk) * zprchln(ji,jj,jk) * xlimphy(ji,jj,jk)
                   zprochln = chlcmin * 12. * zprorcan (ji,jj,jk)
-
-                  ! The maximum reachable Chl quota is modulated by temperature
-                  ! following Geider (1987)
-                  chlcnm_n   = MIN ( chlcnm, ( chlcnm / (1. - 1.14 / 43.4 *tsn(ji,jj,jk,jp_tem))) * (1. - 1.14 / 43.4 * 20.))
-                  zprochln = zprochln + (chlcnm_n-chlcmin) * 12. * zprod / &
+                  zprochln = zprochln + (chlcnm - chlcmin) * 12. * zprod / &
                                         & (  zpislopeadn(ji,jj,jk) * znanotot +rtrn)
 
@@ -350,9 +333,5 @@
                   zprod    = rday * zprorcad(ji,jj,jk) * zprchld(ji,jj,jk) * xlimdia(ji,jj,jk)
                   zprochld = chlcmin * 12. * zprorcad(ji,jj,jk)
-
-                  ! The maximum reachable Chl quota is modulated by temperature
-                  ! following Geider (1987)
-                  chlcdm_n   = MIN ( chlcdm, ( chlcdm / (1. - 1.14 / 43.4 * tsn(ji,jj,jk,jp_tem))) * (1. - 1.14 / 43.4 * 20.))
-                  zprochld = zprochld + (chlcdm_n-chlcmin) * 12. * zprod / &
+                  zprochld = zprochld + (chlcdm - chlcmin) * 12. * zprod / &
                                         & ( zpislopeadd(ji,jj,jk) * zdiattot +rtrn )
 
@@ -386,6 +365,8 @@
                  &                   + ( o2ut + o2nit ) * ( zpronewn(ji,jj,jk) + zpronewd(ji,jj,jk) )
                  !
-                 zfeup = texcretn * zprofen(ji,jj,jk) + texcretd * zprofed(ji,jj,jk)
-                 tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zfeup
+                 tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - ( texcretn * zprofen(ji,jj,jk)    &
+                 &                   + texcretd * zprofed(ji,jj,jk) )
+                 consfe3(ji,jj,jk) = ( texcretn * zprofen(ji,jj,jk) + texcretd * zprofed(ji,jj,jk) )     &
+                 &                    * 75.0 / ( rtrn + ( plig(ji,jj,jk) + 75.0 * (1.0 - plig(ji,jj,jk) ) ) * trb(ji,jj,jk,jpfer) ) / rfact2
                  tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) - zprmaxd(ji,jj,jk) * zysopt(ji,jj,jk)   &
                  &                   * rfact2 * trb(ji,jj,jk,jpdia)
@@ -401,5 +382,5 @@
      ! when ln_ligand is set to .true. in the namelist. Ligand uptake is small 
      ! and based on the FeL model by Morel et al. (2008) and on the study of
-     ! Shaked and Lis (2012)
+     ! Shaked et al. (2020)
      ! -------------------------------------------------------------------------
      IF( ln_ligand ) THEN
@@ -412,8 +393,8 @@
                     zfeup    = texcretn * zprofen(ji,jj,jk) + texcretd * zprofed(ji,jj,jk)
                     tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) + zdocprod * ldocp    &
-                    &       - zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) + 2.E3 * (1.0 - plig(ji,jj,jk) ) ) * lthet
+                    &       - zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) + 75.0 * (1.0 - plig(ji,jj,jk) ) ) * lthet
                     zpligprod1(ji,jj,jk) = zdocprod * ldocp
                     zpligprod2(ji,jj,jk) = zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) &
-                    &                      + 2.E3 * (1.0 - plig(ji,jj,jk) ) ) * lthet
+                    &                      + 75.0 * (1.0 - plig(ji,jj,jk) ) ) * lthet
                  ENDIF
               END DO
